﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private client As MqttClient
	Private ser As B4RSerializator
	Type MqttCommand (ClientName As String, CommandName As String, Tag As Object, Params As List)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (MqttPort As Int)
	client.Initialize("client", "tcp://127.0.0.1:" & MqttPort, "rdc")
	client.Connect
	ser.Initialize
End Sub

Private Sub Client_Connected (Success As Boolean)
	If Success = False Then
		Log("Error connecting to broker")
		ExitApplication
	End If
	client.Subscribe("insert", 0)
	client.Subscribe("select", 0)
End Sub

Private Sub Client_MessageArrived (Topic As String, Payload() As Byte)
	If Topic = "insert" Then
		Insert(Payload)
	Else if Topic = "select" Then
		RunSelect(Payload)
	End If
End Sub

Private Sub RunSelect (Payload() As Byte)
	Dim mc As MqttCommand = PayloadToMqttCommand(Payload)
	Dim con As SQL = Main.rdcConnector1.GetConnection
	Try
		Dim rs As ResultSet = con.ExecQuery2(Main.rdcConnector1.GetCommand(mc.CommandName), mc.Params)
		Dim jrs As JavaObject = rs
		Dim rsmd As JavaObject = jrs.RunMethod("getMetaData", Null)
		Dim cols As Int = rs.ColumnCount
		If rs.NextRow Then
			Dim row(cols + 3) As Object
			For i = 0 To cols - 1
				Dim ct As Int = rsmd.RunMethod("getColumnType", Array(i + 1))
				'check whether it is a blob field
				If ct = -2 Or ct = 2004 Or ct = -3 Or ct = -4 Then
					row(i + 3) = rs.GetBlob2(i)
				Else if ct = 2 Or ct = 3 Then
					row(i + 3) = rs.GetDouble2(i)
				Else
					row(i + 3) = jrs.RunMethod("getObject", Array(i + 1))
				End If
			Next
			row(0) = "select"
			row(1) = mc.Tag
			row(2) = 1
			client.Publish(mc.ClientName, ser.ConvertArrayToBytes(row))
		Else
			client.Publish(mc.ClientName, ser.ConvertArrayToBytes(Array("select", mc.Tag, 0)))
		End If
	Catch
		Log(LastException)
	End Try
	con.Close
End Sub

Private Sub PayloadToMqttCommand(payload() As Byte) As MqttCommand
	Dim mc As MqttCommand
	mc.Initialize
	Dim objects() As Object = ser.ConvertBytesToArray(payload)
	mc.ClientName = objects(0)
	mc.CommandName = objects(1)
	mc.Tag = objects(2)
	mc.Params.Initialize
	For i = 3 To objects.Length - 1
		If objects(i) = "null" Then objects(i) = Null
		mc.params.Add(objects(i))
	Next
	Return mc
End Sub



Private Sub Insert (Payload() As Byte)
	Dim mc As MqttCommand = PayloadToMqttCommand(Payload)
	Log($"Insert from ${mc.ClientName}, Command = ${mc.CommandName}"$)
	Dim success As Boolean
	Dim con As SQL = Main.rdcConnector1.GetConnection
	Try
		con.BeginTransaction
		con.ExecNonQuery2(Main.rdcConnector1.GetCommand(mc.CommandName), _
				mc.params)
		con.TransactionSuccessful
		success = True
	Catch
		con.Rollback
		Log(LastException)
	End Try
	con.Close
	client.Publish(mc.ClientName, ser.ConvertArrayToBytes(Array("insert", mc.Tag, success)))
End Sub
